/* GCC */
#include <bits/stdc++.h>

using namespace std;

struct point
{
    double x;
    double y;
};

void input_point (point &a)
{
    cin>>a.x>>a.y;
}

void swap_point (point &a,point &b)
{
    swap (a.x,b.x);
    swap (a.y,b.y);
}

double maxt(double a,double b,double c)
{
    return max(max(a,b),c);
}

double mint(double a,double b,double c)
{
    return min(min(a,b),c);
}

double point_distance (point a,point b)
{
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}

bool triangle (point a,point b,point c)
{
    return (point_distance(a,b)<point_distance(a,c)+point_distance(b,c)&&point_distance(a,c)<point_distance(a,b)+point_distance(b,c)&&point_distance(b,c)<point_distance(a,c)+point_distance(a,b));
}

double triangle_ploscha (point a,point b,point c)
{
    return abs(maxt(a.x,b.x,c.x)-mint(a.x,b.x,c.x))*abs(maxt(a.y,b.y,c.y)-mint(a.y,b.y,c.y))-abs(a.x-b.x)*abs(a.y-b.y)/2-abs(a.x-c.x)*abs(a.y-c.y)/2-abs(b.x-c.x)*abs(b.y-c.y)/2;
}

bool comp (point a,point b)
{
    point zero;
    zero.x=0;
    zero.y=0;
    return (point_distance(a,zero)<point_distance(b,zero));
}

point mas[2000];
int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    short n;double res=0;
    freopen("triangle.in","r",stdin);
    freopen("triangle.out","w",stdout);
    cin>>n;
    for (int i=0;i<n;i++)
    {
        input_point(mas[i]);
    }
    for (int i=0;i<n;i++)
    {
        for (int j=0;j<n;j++)
        {
            for (int r=0;r<n;r++)
            {
                if (triangle(mas[i],mas[j],mas[r]))
                {
                    if (res<triangle_ploscha(mas[i],mas[j],mas[r]))
                        {
                        res=triangle_ploscha(mas[i],mas[j],mas[r]);
                    }
                }
            }
        }
    }
    cout<<res<<'\n';
    return 0;
}
