/* GCC */
#include <bits/stdc++.h>

using namespace std;
long long n;
bool matrix[2000][2000];
const long long inf = 1000000000000;
long long BFS(long long a,long long b){
    if(matrix[a][b])
        return 1;
    queue <long long> mass;
    vector <bool> visited(n);
    mass.push(a);
    long long c = 0;
    long long dist[n];
    for(long long i = 0;i<n;i++){
        dist[i] = inf;
    }
    visited[a] = 1;
    dist[a] = 0;
    while(mass.size()){
        long long x = mass.front();
        for(long long i = 0;i<n;i++){
            if(matrix[x][i] && !visited[i]){
                mass.push(i);
                dist[i] = min(dist[i],dist[x]+1);
                visited[i] = 1;
            }
        }
        mass.pop();
        c++;
    }
    return dist[b];
}
int main()
{

    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    long long m,a;
    cin >> n >> m >> a;
    for(long long i = 0;i<n;i++){
        for(long long j = 0;j<n;j++){
            matrix[i][j] = 0;
        }
    }
    for(long long i = 0;i<m;i++){
        long long x,y;
        cin >> x >> y;
        x--;
        y--;
        matrix[x][y] = matrix[y][x] = 1;
    }
    long long s = inf;
    long long massiv[a];
    for(long long i = 0;i<a;i++){
        cin >> massiv[i];
        massiv[i] --;
    }
    for(long long i = 0;i<a-1;i++){
        for(long long j = i+1;j<a;j++){
            s = min(s,BFS(massiv[i],massiv[j]));
        }
    }
    cout << s << endl;

}
