/* GCC */
#include <iostream>
#include <fstream>
#include <queue>
#include <vector>

using namespace std;

int main()
{
    ifstream fin;
    fin.open("hiking.in");
    int n, m, k;
    fin >> n >> m >> k;
    if (n*(n-1) - 2*m < k*(k-1)){
        ofstream fout;
        fout.open("hiking.out");
        fout << 1 << endl;
        fout.close();
        return 0;
    }
    vector<vector<int> > v(n);
    for (int i = 0; i < m; i++){
        int x, y;
        fin >> x >> y;
        v[x-1].push_back(y-1);
        v[y-1].push_back(x-1);
    }
    int ostanovka[k];
    bool isOst[n];
    for (int i = 0; i < n; i++){
        isOst[i] = false;
    }
    for (int i = 0; i < k; i++){
        fin >> ostanovka[i];
        ostanovka[i]--;
        isOst[ostanovka[i]] = true;
    }
    fin.close();
    int min_d = 1000000000;
    for (int i = 0; i < k; i++){
        queue<pair<int, int> > q;
        //cout << ostanovka[i] << ":" << endl;
        q.push(pair<int, int>(ostanovka[i], 0));
        bool u[n];
        for (int j = 0; j < n; j++){
            u[j]=false;
        }
        u[ostanovka[i]] = true;
        while (!q.empty()){
            int x = q.front().first;
            int z = q.front().second;
            q.pop();
            if (x != ostanovka[i] && isOst[x] && z < min_d){
                //cout << ostanovka[i]+1 << " - " << x+1 << " : " << z << endl << endl;
                min_d = z;
            }
            for (unsigned int j = 0; j < v[x].size(); j++){
                if (!u[v[x][j]]){
                    q.push(pair<int, int>(v[x][j], z+1));
                    u[v[x][j]] = true;
                }
            }
        }
    }
    ofstream fout;
    fout.open("hiking.out");
    fout << min_d << endl;
    fout.close();
    return 0;
}






