""" Python 3 """
def harvest(cont_lim1, cont_lim2, cucumber1, cucumber2): #cucumber1 = 5/30 cont, cucumber2 = 6/30 cont
    if cont_lim2 <= cucumber2:
        cucumber2 -= cont_lim2
    elif cont_lim2 > cucumber2:
        if cont_lim1 <= cucumber1:
            cucumber1 -= cont_lim1
        elif cont_lim1 > cucumber1:
            free_space = (cucumber2 * cont_lim2) / 30
            cucumber2 = 0
            cucumber1 -= round(free_space * cont_lim1)
    return cucumber1, cucumber2


def check(num, limit):
    if num > limit:
        exit()


spore_shot = []
lifespan_max = 10
year_max = 2 ** 64
nsk_max = 2 ** 32

with open('cucumbers.in', 'r') as file:
    data = file.read()
    data = data.strip().split()
    file.close()
    year = int(data[0])
    lifespan = int(data[1])

    spore_shot.append(int(data[2]))
    spore_shot.append(int(data[3]))

    cont_lim1 = int(data[4])
    cont_lim2 = int(data[5])
    
    num_limit = [lifespan_max, year_max]
    num_check = [lifespan, year]
    for i in range(len(num_check)):
        check(num_check[i], num_limit[i])

spore = 1
cucumber1 = cucumber2 = 0

for i in range(year):
    state1 = [spore, cucumber1, cucumber2]
    state2 = []
    state2.append((state1[0] * spore_shot[0]) + (state1[1] * spore_shot[1]))
    state2.append(spore)
    state2.append(cucumber1)
    state1, spore, cucumber1, cucumber2 = state2, state2[0], state2[1], state2[2]
cucumber1, cucumber2 = harvest(cont_lim1, cont_lim2, cucumber1, cucumber2)

with open('cucumbers.out', 'w') as file:
    file.write('{} {}'.format(cucumber1, cucumber2))
