/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

int main()
{
    int m, n, a[9], b[9], system[10];
    ifstream f1;
    f1.open("cucumbers.in");
    f1 >> m >> n;
    for (int i = 0; i < n; i++)
    {
        f1 >> a[i];
    }
    for (int i = 0; i < n; i++)
    {
        f1 >> b[i];
    }
    f1.close();
    system[0]=1;
    for (int j = 1; j < n+1; j++)
    {
        system[j] = 0;
    }

    for (int i = 0; i < m; i++)
    {
        for (int j = n; 0 < j; j--)
        {
            system[j]=system[j-1];
        }
        system[0]=0;
        for (int j = 1; j < n+1; j++)
        {
            system[0] = system[0]+system[j]*a[j-1];
        }
    }
    int answer[9];


    ofstream f2;
    f2.open("cucumbers.out");
    for (int i = 0; i < n; i++)
    {
        answer[i] = fmod(system[i+1], b[i]);
        f2 << answer[i] << " ";
    }
    f2.close();
    return 0;
}
