/* GCC */
#include <bits/stdc++.h>

using namespace std;

const int nmax = 2000;
struct pt
{
    double x , y;
};
void mas_in(int & n , pt mas[])
{
    cin >> n;
    for(int i = 0 ; i < n; i ++)
        cin >> mas[i].x >> mas[i].y;
}

double dstc(pt a , pt b)
{
    return sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
}

double dist_to_sec(pt sec1 , pt sec2 , pt point)
{
    double p = (dstc(sec1 , sec2 ) + dstc(sec1 , point) + dstc(sec2 , point))/2;
    double s = sqrt(p * (p -dstc(sec1 , sec2 )) * (p - dstc(sec1 , point )) * (p - dstc(point , sec2 )) );
    return min(dstc(sec1 , point) , min(dstc(sec2 , point) , 2 * s / dstc(sec1 , sec2 )));
}

int main()
{
    freopen("triangle.in" , "r" , stdin);
    freopen("triangle.out" , "w" , stdout);
    int n ;
    pt mas[2000];
    mas_in(n , mas);
    pt point1 , point2 , point3;
    double max1 = 0 , max2 = 0;
    for(int i = 0 ; i < n ; i ++)
    {
        for(int j = i + 1 ; j  < n ; j ++)
            if(dstc(mas[i] , mas[j])>  max1 )
            {
                max1 = dstc(mas[i] , mas[j]);
                point1 = mas[i];
                point2 = mas[j];
            }
    }
    double len = dstc(point1 , point2);
    for(int i = 0 ; i < n ; i ++)
    {
        if(dist_to_sec(point1 , point2 , mas[i]) > len)
            point3 = mas[i];
    }
    cout << abs(point1.x * ( point2.y - point3.y) + point2.x * ( point3.y - point1.y) + point3.x * ( point1.y - point2.y))/2 << "\n";
    return 0;
}
