/* GCC */
#include <iostream>
#include <cstdio>
#define ll unsigned long long int

using namespace std;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

ll lcm(ll a, ll b) {
    return (a / gcd(a, b)) * b;
}

int main() {
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    std::ios_base::sync_with_stdio(false);
    ll m, n;
    cin >> m >> n;
    ll* a = new ll[n];
    ll lcm_a;
    cin >> a[0];
    lcm_a = a[0];
    for (ll i = 1;i < n;i++) {
        cin >> a[i];
        lcm_a = lcm(lcm_a, a[i]);
    }
    ll lcm_b;
    ll* b = new ll[n];
    cin >> b[0];
    lcm_b = b[0];
    for (ll i = 1;i < n;i++) {
        cin >> b[i];
        lcm_b = lcm(lcm_b, b[i]);
    }
    ll lcm_all = lcm(lcm_a, lcm_b);
    ll* fs = new ll[n + 1];
    fs[0] = 1;
    for (ll i = 1;i < n + 1;i++) {
        fs[i] = 0;
    }
    for (ll i = 0;i < m;i++) {
        for (ll j = n;j > 0;j--) {
            fs[j] = fs[j - 1];
        }
        for (ll j = 1;j <= n;j++) {
            fs[j] %= lcm_all;
        }
        ll sum = 0;
        for (ll j = 1;j <= n;j++) {
            sum += fs[j] * a[j - 1];
        }
        fs[0] = sum;

    }
    for (ll j = 1;j <= n;j++) {
        if (j == n)
            cout << fs[j] % b[j - 1];
        else
            cout << fs[j] % b[j - 1] << " ";
    }
    cout << endl;
    fclose(stdout);
    fclose(stdin);
    return 0;
}
