/* GCC */
#include <fstream>
#include <math.h>

using namespace std;

double dlina(short int x1, short int y1, short int x2, short int y2){
    return sqrt(pow(x1 - x2, 2) + pow(y1 - y2, 2));
}

double s(short int x1, short int y1, short int x2, short int y2, short int x3, short int y3){
    double a, b, c, p;
    a = dlina(x1, y1, x2, y2);
    b = dlina(x2, y2, x3, y3);
    c = dlina(x3, y3, x1, y1);
    p = (a + b + c) / 2;
    return sqrt(p*(p-a)*(p-b)*(p-c));
}

int main(){
    ifstream file1;
    ofstream file2;
    file1.open("triangle.in");
    file2.open("triangle.out");
    double max1 = 0;
    short int n;
    file1 >> n;
    double  arr[n][n][n];
    short int coords[n][n];
    for (short int i = 0; i < n; i++){
        file1 >> coords[i][0];
        file1 >> coords[i][1];
    }


    for ( short int i = 0; i < n; i++){
        for( short int j = 0; j < n; j++){
            for( short int a = 0; a < n; a++){
                arr[i][j][a] = 0;
                if (i != j && i != a && a != j){
                    if((arr[i][a][j] == 0) && (arr[j][i][a] == 0) && (arr[j][a][i] == 0) && (arr[i][a][j] == 0) && (arr[i][j][a] == 0)){
                        arr[i][j][a] = s(coords[i][0], coords[i][1], coords[j][0], coords[j][1], coords[a][0], coords[a][1]);
                        if(arr[i][j][a] > max1) max1 = arr[i][j][a];
                    }
                }
            }
        }
    }
    file2 << max1;
    file2 << endl;
    file1.close();
    file2.close();
}
