/* GCC */

#include <iostream>
#include <cstdio>
#define INF 10000

using namespace std;

int main() {
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);

    int n = 0, m = 0, k = 0;
    cin >> n >> m >> k;
    int a[n][n];
    int v[k];
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            a[i][j] = (i == j ? 0 : INF);
        }
    }

    for(int i = 0; i < m; i++) {
        int f = 0, s = 0;
        cin >> f >> s; f--; s--;
        a[f][s] = a[s][f] = 1;
    }
    for(int i = 0; i < k; i++) {
        v[i] = 0;
        cin >> v[i];
        v[i]--;
    }

    for(int k = 0; k < n; k++) {
        for(int i = 0; i < n; i++) {
            for(int j = 0; j < n; j++) {
                if(a[i][j] > a[i][k] + a[k][j])
                   a[i][j] = a[i][k] + a[k][j];
            }
        }
    }

    int mn = INF;
    for(int i = 0; i < k; i++) {
        for(int j = i + 1; j < k; j++) {
            if(mn > a[v[i]][v[j]])
               mn = a[v[i]][v[j]];
        }
    }

    cout << mn << endl;

    return 0;
}
