/* GCC */

#include <fstream>
#include <cmath>

long s(int x1, int y1, int x2, int y2, int x3, int y3){
    long a1 = (x2 - x3) * (x2 - x3) + (y2 - y3) * (y2 - y3);
    long a2 = (x1 - x3) * (x1 - x3) + (y1 - y3) * (y1 - y3);
    long a3 = (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2);

    a1 = sqrt(a1);
    a2 = sqrt(a2);
    a3 = sqrt(a3);

    long p = (a1 + a2 + a3) / 2;

    return sqrt(p * (p - a1) * (p - a2) * (p - a3));
}

using namespace std;

int main(){

    ifstream fin;
    fin.open("triangle.in");
    ofstream fout;
    fout.open("triangle.out");

    long n, t;

    fin >> n;

    int x[n], y[n];

    for(int z = 0; z < n; z++){
        fin >> x[z] >> y[z];
    }

    long h[n][n][n];

    t = s(x[0], y[0], x[0], y[0], x[0], y[0]);

    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            for(int k = 0; k < n; k++){
                h[i][j][k] = s(x[i], y[i], x[j], y[j], x[k], y[k]);
                if(t < h[i][j][k]){
                    t = h[i][j][k];
                }
            }
        }
    }

    fout << t << endl;

    fin.close();
    fout.close();

    return 0;
}
