/* GCC */
#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;

double leng(int x1, int y1, int x2, int y2)
{
    double ax = abs(x1 - x2);
    double ay = abs(y1 - y2);
    return sqrt(ax*ax + ay*ay);
}

int main()
{
    ifstream fin("triangle.in");
    ofstream fout("triangle.out");

    int N;
    fin >> N;
    int Arr[N][2];
    for (int i = 0; i< N; i++)
    {
        fin >> Arr[i][0] >> Arr[i][1];
    }
    double maxS2 = 0;

    for (int i1 = 0; i1 < N - 2; i1++)
    {
        for (int i2 = 1; i2 < N-1; i2++)
        {
            for (int i3 = 2; i3 < N; i3++)
            {
                double a = leng(Arr[i1][0], Arr[i1][1], Arr[i2][0], Arr[i2][1]);
                double b = leng(Arr[i1][0], Arr[i1][1], Arr[i3][0], Arr[i3][1]);
                double c = leng(Arr[i3][0], Arr[i3][1], Arr[i2][0], Arr[i2][1]);
                double p = (a + b + c) / 2;
                double S2 = p * (p - a) * (p - b) * (p - c);
                if (S2 > maxS2)
                {
                    maxS2 = S2;
                }
            }
        }
    }

    fout << sqrt(maxS2);
}
