/* GCC */

#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

long long gcd(long long a,long long b)
{
    if (a == 0) return b;
    if (b == 0) return a;
    if (a > b) return gcd(b,a%b);
    return gcd(a,b%a);
}

int main()
{
    freopen("cucumbers.in","r",stdin);
    freopen("cucumbers.out","w",stdout);
    long long m,n;
    cin >> m >> n;
    vector<long long> a(n+1);
    vector<long long> b(n+1);
    vector<long long> x(n);
    x[0] = 1;
    long long i,j;
    long long nsk = 1;
    for (i = 1;i <= n;i++) cin >> a[i];
    for (i = 1;i <= n;i++)
    {
        cin >> b[i];
        nsk = nsk*b[i]/gcd(nsk,b[i]);
    }
    for (i = 1;i <= m-1;i++)
    {
        long long c = 0;
        for (j = 1;j <= n;j++) c = (c+a[j]*x[(i+n-j)%n])%nsk;
        x[i%n] = c;
    }
    vector<long long> ans(n);
    for (i = 0;i < n;i++) ans[i] = x[(m-1-i+n)%n]%b[i+1];
    cout << ans[0];
    for (i = 1;i < n;i++) cout << " " << ans[i];
    cout << "\n";
}
