/* GCC */

#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>

using namespace std;

int main()
{
    freopen("hiking.in","r",stdin);
    freopen("hiking.out","w",stdout);
    int n,m,k;
    cin >> n >> m >> k;
    vector<vector<int> > arr(n+1);
    int i,j;
    for (i = 1;i <= m;i++)
    {
        int a,b;
        cin >> a >> b;
        (arr[a]).push_back(b);
        (arr[b]).push_back(a);
    }
    vector<bool> bus(n+1,false);
    for (i = 1;i <= k;i++)
    {
        int a;
        cin >> a;
        bus[a] = true;
    }
    int ans = n-1;
    for (i = 1;i <= n;i++)
    {
        if(!bus[i]) continue;
        vector<int> dist(n+1,0);
        vector<bool> used(n+1);
        used[i] = true;
        queue<int> q;
        q.push(i);
        while(!q.empty())
        {
            int s = q.front();
            int f = 1;
            for(j:arr[s])
            {
                if (bus[j] && !used[j])
                {
                    ans = min(1+dist[s],ans);
                    f = 0;
                    break;
                }
                if(!used[j])
                {
                    q.push(j);
                    used[j] = true;
                    dist[j] = dist[s]+1;
                }
            }
            if(f == 0) break;
            q.pop();
        }
    }
    cout << ans << "\n";
}

