#include <fstream>
#include <vector>

int main()
{
    std::ifstream in("hiking.in");
    std::ofstream out("hiking.out");

    int n, m, k;
    in >> n >> m >> k;

    std::vector<int> * destinations = new std::vector<int> [n]();
    for(int i = 0; i < n; i++)
    {
        destinations[i].empty();
    }

    for(int i = 0; i < m; i++)
    {
        int from = 0, to = 0;
        in >> from >> to;
        destinations[std::min(from, to)].push_back(std::max(from, to));
    }

    int * lengths = new int[n]();
    bool * accessed = new bool[n]();

    for(int i = 0; i < n; i++)
    {
        accessed[i] = false;
        lengths[i] = 4096;
    }

    for(int i = 0; i < k; i++)
    {
        int t = 0;
        in >> t;
        accessed[t - 1] = true;
        lengths[t - 1] = 0;
    }

    while(true)
    {
        for(int i = 0; i < n; i++)
        {
            if(lengths[i] != 4096)
            {
                for(int j : destinations[i])
                {
                    lengths[j] = lengths[i] + 1;

                    if(accessed[j] == true)
                    {
                        out << lengths[i] + 1;
                        return 0;
                    }

                }

            }
        }
    }

    delete[] accessed;
    delete[] lengths;

    return 0;
}
