/* GCC */
#include <bits/stdc++.h>

using namespace std;
vector<vector<int> > v;
vector<bool> flag;
const int INF = 2010;
int global_deep = INF;
vector<bool> used;

void dfs(int ap, int timer)
{
    used[ap] = true;
    if(flag[ap] && timer != 0)
    {
        global_deep = min(timer, global_deep);
        return;
    }
    if(timer == global_deep)
        return;

    for(int i = 0; i < v[ap].size(); i++)
    {
        int to = v[ap][i];
        if(!used[to])
            dfs(to, timer + 1);
    }
}

int main()
{
    freopen("hiking.in", "rt", stdin);
    freopen("hiking.out", "wt", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin>> n >> m >> k;
    v.resize(n);

    for(int i = 0; i < m; i++)
    {
        int a, b;
        cin>> a >> b;
        v[a - 1].push_back(b - 1);
        v[b - 1].push_back(a - 1);
    }

    flag.resize(n, false);
    vector<int> help(k);

    for(int i = 0; i < k; i++)
    {
        int a;
        cin>> a;
        flag[a - 1] = true;
        help[i] = a - 1;
    }
    used.resize(n);

    for(int i = 0; i < k; i++)
    {
        for(int j = 0; j < n; j++)
            used[j] = false;
        dfs(help[i], 0);
    }

    cout<< global_deep << "\n";

    return 0;
}
