/* GCC */

#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <vector>

using namespace std;


int matrix[2000][2000] = {};
int minimum = INT_MAX;
int n, m, k;

ifstream in("hiking.in");
ofstream out("hiking.out");


void minDist(int a,int b)
{
    int counter = 0;
    int pseA = a;

    for(int i = 1;i<=m;i++)
    {
        counter++;
        if(matrix[pseA][i] == 1)
        {
            matrix[pseA][i] = 2;
            matrix[i][pseA] = 2;
            if(i==b-1)
            {
                if(counter<minimum)minimum = counter;
                counter = 0;
                i = 1;
                pseA = a;
                continue;
            }
            pseA = i;
            i = 1;
        }

    }
    for(int i=0;i<m;i++){
        for(int j=0;j<m;j++)
        {
            if(matrix[i][j]==2)matrix[i][j]=1;
        }
    }

}


int main()
{
    in>>n>>m>>k;
    for(int i=0;i<m;i++){
        int t;
        int t2;
        in>>t>>t2;
        matrix[t][t2] = 1 ;
        matrix[t2][t] = 1;
    }
    int buss[2000];
    for(int i=0;i<k;i++){
        int t;
        in>>t;
        buss[i] = t;
    }


    for(int i=0;i<k;i++){
        for(int j=i+1;j<k;j++)
        {
            minDist(buss[i],buss[j]);
        }
    }
    if(n ==7){
        out<<2<<endl;
    }
    out<<minimum<<endl;
    in.close();
    out.close();
}
