/* GCC */
#include <bits/stdc++.h>

using namespace std;

const int Nmax = 2222;
vector<int> g[Nmax];
int pr[Nmax], d[Nmax];


int main()
{
	freopen("hiking.in", "r", stdin);
	freopen("hiking.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m;
    cin >> k;


    int a, b;
    for(int i = 0;i < m;++i) {
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(int i = 0;i < n;++i)
        pr[i] = -1;
    queue<int> q;
    int hv;
    for(int i = 0;i < k;++i) {
        cin >> hv;
        hv--;
        q.push(hv);
        pr[hv] = hv;
        d[hv] = 0;
    }

    int v, to;
    while(!q.empty()) {
        v = q.front();
        q.pop();
        for(int i = 0;i < g[v].size();++i) {
            to = g[v][i];
            if(pr[to] == -1) {
                pr[to] = pr[v];
                d[to] = d[v] + 1;
                q.push(to);
            }
        }
    }

    int ans = Nmax<<2;
    for(int v = 0;v < n;++v) {
        for(int i = 0;i < g[v].size();++i) {
            to = g[v][i];
            if(pr[to] != pr[v])
                ans = min(ans, d[to]+d[v]+1);
        }
    }

    cout << ans << '\n';
    return 0;
}
