/* GCC */



#include <bits/stdc++.h>

#define pii pair<int,int>

#define x first
#define y second

#define en '\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const ll INF64=1000000000000000000;
const int INF32=1000000000;

using namespace std;

const int MAXn=2001;

vector <int> stops;

bitset <MAXn> G[MAXn];

bitset <MAXn> BS;

bitset <MAXn> help;

bool iss_stop[MAXn];

int pos;

int len[MAXn];

int ans=INF32;

void BFS(int v){
    BS.reset();
    BS.flip();
    queue<int> q;
    q.push(v);
    len[v]=0;
    while (q.size()){
        v=q.front();
        q.pop();
        BS[v]=0;
        help=BS&G[v];
        pos=0;
        while (1){
            pos=help._Find_first();
            if (pos==MAXn) break;
            q.push(pos);
            len[pos]=len[v]+1;
            if (iss_stop[pos]){
                ans=min(len[pos],ans);
                return;
            }
            BS[pos]=0;
            help[pos]=0;
        }
    }
}



int main(void){
    freopen("hiking.in","r",stdin);
    freopen("hiking.out","w",stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n,m,k;
    cin>>n>>m>>k;
    int fr,to;
    for (int i=1; i<=m; ++i){
        cin>>fr>>to;
        G[fr][to]=1;
        G[to][fr]=1;
    }
    for (int i=1;  i<=k; ++i){
        cin>>fr;
        stops.push_back(fr);
        iss_stop[fr]=1;
    }
    for (int i=0; i<k; ++i){
        BFS(stops[i]);
    }


    cout<<ans<<en;
    return 0;
}
