#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

long long Multi(long long a, long long b, long long m) {
     if (b==0) return 0;
     long long l = Multi(a,b/2,m);
     l=(l + l)%m;
     if (b%2==1) l = (l+a)%m;
     return l;     
}

long long solve(long long a, long long n, long long m) {
     if (n==0) return (1%m);
     long long l=solve(a,n/2,m);
     l=Multi(l,l,m);
     if (n%2==1) l=Multi(a,l,m);
     return l;     
}

int main() {
    freopen("cucumbers.in","r",stdin);
    freopen("cucumbers.out","w",stdout);
    long long n, m;
    long long a[10], b[10];
    long long i, j;
    cin>>m>>n;
    for (i=1; i<=n; i++)
        cin>>a[i];
    for (j=1; j<=n; j++)
        cin>>b[j];
    if (n==1) {
       cout<<solve(a[1],m,b[1])<<endl;
       return 0;          
    }
    vector <long long> x;
    x.push_back(0);
    x.push_back(1);
    long long val;
    for (i=2; i<=m; i++) {
        val=0;
        for (j=i-1; ((j>=0) && (j>=i-n)); j--)
            val+=a[i-j]*x[j];
        x.push_back(val);                    
    }
    //for (i=0; i<=m; i++)
    //    cout<<x[i]<<" ";
    //cout<<endl;
    i=m;
    for (j=1; j<n; j++) {
        if (i<0) cout<<"0 "; else {
           cout<<x[i]%b[j]<<" ";
           i--;         
        }    
    }
    if (i<0) cout<<0<<endl; else cout<<x[i]%b[n]<<endl;
}
