/* GCC */

#include <vector>
#include <map>
#include <iostream>
#include <iomanip>
#include <set>
#include <cmath>
#include <fstream>

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int maxn = 10;
const ll  maxnum = 5e4 + 1;
ll a[maxn];
ll b[maxn];
vector <ll> arr(maxn);
multiset <int> fact[10];
vector<int> prime;
map <vector<ll>, int> order;
map <int, vector<ll> > order_reverse;
bool used[maxnum];
void era(ll n){
    for(ll i = 2; i < n; ++i){
        if(!used[i]){
            prime.push_back(i);
            for(ll j = i * i; j < n; j+=i)
                    used[j] = 1;
        }
    }
}
ll nod(ll a, ll b){
    ll ans = 1;
    for(int i = 0; i < prime.size() && prime[i] <= sqrt(min(a,b)) + 2; ++i){
        int p = prime[i];
        while(a % p == 0 && b % p == 0){
            ans*=p;
            a/=p;
            b/=p;
        }
    }
    return ans;
}
ll nsk(ll a, ll b){
    ll ans = a /  nod(a,b) * b;
    return ans;
}
int main()
{
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    ll m;
    cin >> m >> n;
    arr[0] = 1;
    for(int i = 1; i <= n; ++i)
        cin >> a[i];
    for(int i = 1; i <= n; ++i)
        cin >> b[i];
    ll t;
    t = b[1];
    if(n >= 2){
        era(maxnum);
        for(int i = 2; i <=n; ++i){
            t = nsk(t, b[i]);
        }
    }
    for(int i = 1; i <=n; ++i)
        a[i]%=t;
    ll temp;
    ll left =0, period = 12345 - 1;
    for(ll i = 1; i <= min(12345ll, m); ++i){
        for(int j = n; j > 0; --j)
            arr[j]= arr[j - 1];
        arr[0] = 0;
        for(int j = 1;j <= n; ++j)
            arr[0]= (arr[0] + (arr[j] * a[j])%t) % t;
        if(order[arr]){
            left = order[arr];
            period = i - order[arr];
            break;
        }
        else{
            order[arr] = i;
            order_reverse[i] = arr;
        }
    }
    if(m > left + period){
        m-=left;
        m%=period;
        m+=left;
    }
    for(int i = 1; i <= n - 1; ++i){
        cout << order_reverse[m][i] % b[i] << " ";
    }
    cout << order_reverse[m][n] % b[n] << '\n';
    return 0;
}
