/* GCC */

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int maxn = 2e3 + 1;
const int inf = 1e9 + 9;
vector <int> graph[maxn];
int d[maxn][maxn];
bool used[maxn][maxn];
queue <int> que;
void bfs(int v){
    que.push(v);
    used[v][v] = 1;
    while(!que.empty()){
        int cur = que.front();
        for(int i = 0; i < graph[cur].size(); ++i){
            int t = graph[cur][i];
            if(used[v][t])
                continue;
            d[v][t]= d[v][cur] + 1;
            used[v][t] = 1;
            que.push(t);
        }
        que.pop();
    }
}
int main()
{
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);
    int n,m,k;
    cin >> n >> m >> k;
    for(int i = 0; i < m; ++i){
        int a,b;
        cin >>a >>b;
        a--;
        b--;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }
    int t;
    int mini = inf;
    vector<int> stops;
    for(int i = 0; i < k; ++i){
        cin >> t;
        t--;
        stops.push_back(t);
        bfs(t);
        for(int i = 0; i < n; ++i){
            if(i == t)
                continue;
        }
    }
    for(int i = 0; i < stops.size(); ++i){
        for(int j = 0; j < stops.size(); ++j){
            if(i!=j){
                int a = stops[i], b = stops[j];
                mini = min(mini, d[a][b]);
            }
        }
    }
    cout << mini << '\n';
    return 0;
}
