/* GCC */
#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

long long mod;
vector<long long> b,a;
vector<vector<long long> > M;
vector<vector<long long> > c;
vector<vector<long long> > s;
long long n,m;

//void print(vector<vector<long long> > c){
//    for(long i = 0;i < c.size();i++){
//        for(long j = 0;j < c[i].size();j++)
//            cout << c[i][j] << ' ';
//        cout << '\n';
//    }
//    cout << '\n';
//}

vector<vector <long long> > mult(vector<vector <long long> > d,vector<vector <long long> > e){
    long long s1 = d.size(),s2 = e[0].size();
    vector<vector <long long> > c;
    c.assign(s1,vector<long long> (s2,0));
    for(long i = 0;i < s1;i++)
        for(long j = 0;j < s2;j++)
            for(long k = 0;k < n;k++){
                c[i][j] += d[i][k]*e[k][j];
                c[i][j] %= mod;
            }
    return c;
}

vector<vector<long long> > mpow(vector<vector<long long> > m,long long b){
    if(b == 1){
        return m;
    }
    vector<vector<long long> > t = mpow(m,b/2);
    if(b%2==0)return mult(t,t);
    else return mult(m,mult(t,t));
}

long long gcd(long long a,long long b){
    while(a){
        b %= a;
        swap(a,b);
    }
    return max(a,b);
}

int main()
{
    freopen("cucumbers.in","r",stdin);
    freopen("cucumbers.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> m >> n;
    a.resize(n);
    b.resize(n);
    for(long i = 0;i < n;i++)cin >> a[i];
    for(long i = 0;i < n;i++)cin >> b[i];
    if(m == 1){
        cout << 1%b[0] << ' ';
        for(long i = 1;i < n;i++)
            if(i == n-1)cout << 0 << '\n';
            else cout << 0 << ' ';
        return 0;
    }
    mod = b[0];
    for(long i = 1;i < n;i++){
        mod = (mod*b[i])/gcd(mod,b[i]);
    }
    c.assign(n,vector<long long> (n,0));
    s.assign(1,vector<long long> (n,0));
    s[0][0] = 1;
    for(long i = 0;i < n;i++)
        c[i][0] = a[i];
    for(long i = 1;i < n;i++)
        c[i-1][i] = 1;
    c = mpow(c,m-1);
    for(long i = 0;i < n;i++)
        if(i != n-1)cout << c[0][i]%b[i] << ' ';
        else cout << c[0][i]%b[i] << '\n';
    return 0;
}
