/* GCC */
#include <iostream>
#include <vector>
#include <queue>
#include <cstdio>

using namespace std;

const long nmax = 2010;
const long inf = 99999999;


vector<long> g[nmax];
long bs[nmax];
long ans = inf;
long d[nmax];
bool stop[nmax];
queue <long> q;
long n,m,k;

void bfs(long v){
    for(long i = 0;i < n;i++)
        d[i] = inf;
    while(!q.empty())
        q.pop();
    q.push(v);
    d[v] = 0;
    while(!q.empty()){
        long t = q.front();
        q.pop();
        for(long i = 0;i < g[t].size();i++){
            long to = g[t][i];
            if(d[to] > d[t] + 1){
                d[to] = d[t] + 1;
                if(stop[to]){
                    ans = min(ans,d[to]);
                    return;
                }
                q.push(to);
            }
        }
    }
}

int main()
{
    freopen("hiking.in","r",stdin);
    freopen("hiking.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n >> m >> k;
    for(long i = 0;i < n;i++){
        g[i].clear();
        stop[i] = 0;
    }
    for(long i = 0;i < m;i++){
        long a,b;
        cin >> a >> b;
        a--;b--;
        if(a == b)continue;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for(long i = 0;i < k;i++){
        cin >> bs[i];
        bs[i]--;
        stop[bs[i]] = 1;
    }
    for(long i = 0;i < k;i++){
        bfs(bs[i]);
        if(ans == 1)break;
    }
    cout << ans << '\n';
    return 0;
}
