/* GCC */

#include <iostream>
#include <math.h>
#include <cstdio>
#include <vector>

using namespace std;

double length(int xa, int ya, int xb, int yb)
{
    int dx = xa - xb, dy = ya - yb;
    if (dx < 0) { dx *= -1; }
    if (dy < 0) { dy *= -1; }
    return sqrt((dx * dx) + (dy * dy));
}

double S(int x1, int y1, int x2, int y2, int x3, int y3)
{
    double a = length(x1, y1, x2, y2), b = length(x1, y1, x3, y3), c = length(x3, y3, x2, y2);
    double p = (a + b + c) / 2;
    return sqrt(p*(p - a)*(p - b)*(p - c));
}

int main()
{
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    vector<int> x, y;
    int a;
    cin >> a;
    for (int i = 0; i < a; ++i)
    {
        int t;
        cin >> t;
        x.push_back(t);
        cin >> t;
        y.push_back(t);
    }
    double k = 0;
    int r = x.size();
    for (int i = 0; i < r; ++i)
    {
        for (int u = 0; u < r; ++u)
        {
            for (int o = 0; o < r; ++o)
            {
                double t = S(x[i], y[i], x[u], y[u], x[o], y[o]);
                if (t > k) k = t;
            }
        }
    }
    cout << k << endl;
}
