/* GCC */
#include <iostream>
#include <fstream>

using namespace std;

int nod(int a, int b){
    while (b != 0){
        int c = a%b;
        a = b;
        b = c;
    }
    return a;
}

long long nok(int* b, int n){
    if (n == 1){
        return b[0];
    } else {
        b[1] = (b[0]/nod(b[0], b[1]))*b[1];
        return nok(b+1, n-1);
    }
}

int main()
{
    ifstream fin;
    fin.open("cucumbers.in");
    int n, m;
    fin >> m >> n;
    int a[n+1];
    int b[n+1];
    for (int i = 1; i <= n; i++){
        fin >> a[i];
    }
    for (int i = 1; i <= n; i++){
        fin >> b[i];
    }
    int x[n+1];
    for (int i = 1; i <= n; i++){
        x[i] = 0;
    }
    x[0] = 1;
    fin.close();
    int B = nok(b+1, n);
    for (int i = 0; i < m; i++){
        long long s = 0;
        for (int j = n; j > 0; j--){
            x[j] = x[j-1];
            s += x[j] * a[j];
            if (s >= B){
                s -= B;
            }
        }
        x[0] = s;
    }
    ofstream fout;
    fout.open("cucumbers.out");
    if (n >= 1){
        fout << x[1]%b[1];
    }
    for (int i = 2; i <= n; i++){
        fout << " " << x[i]%b[i];
    }
    fout << endl;
    fout.close();
    return 0;
}




