/* GCC */
#include <bits/stdc++.h>

using namespace std;

struct point
{
    double x,y;
};

void input (point m[], int &n)
{
    cin>>n;
    for (int i=0; i<n; i++)
        cin>>m[i].x>>m[i].y;
}

double len (point a, point b)
{
    return hypot(a.x-b.x,a.y-b.y);
}

double geron (point a, point b, point c)
{
    double aa=0, bb=0, cc=0, p=0, s=0;
    aa=len(b,c);
    bb=len(a,c);
    cc=len(a,b);
    p=(aa+bb+cc)/2;
    s=sqrt(p*(p-aa))*sqrt((p-bb)*(p-cc))*1.0;
    return s;
}

point vec_cord(point a, point b)
{
    point ans={b.x-a.x,b.y-a.y};
    return ans;
}

bool col(point a, point b)
{
    if (a.x*b.y==b.x*a.y) return true;
    return false;
}

bool col_triangle(point a, point b, point c)
{
    point aa=vec_cord(a,b),
          bb=vec_cord(a,c),
          cc=vec_cord(b,c);
    if (col(aa,bb) && col(bb,cc) && col(aa,cc)) return true;
    return false;
}

bool comp (point a, point b)
{
    if (a.x==b.x) return a.y<b.y;
    return a.x<b.x;
}

double min_s(point m[], int n)
{
    if (n==3)
    {
        if (col_triangle(m[0],m[1],m[2])) return 0;
        return geron(m[0],m[1],m[2]);
    }
    sort(m,m+n,comp);
    return geron(m[1], m[n-2], m[n-1]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    freopen("triangle.in","r",stdin);
    freopen("triangle.out","w",stdout);
    int n=0;
    point m[6000]={0};
    input(m,n);
    cout<<min_s(m,n)<<"\n";
    return 0;
}
