/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int N, M, K;
vector < vector < int > > Matrix;
vector < int > que;
int min_path = 0, path;

void ClearMatrix(int Matrix[])
{
    for (int i = 0; i < N; i++)
    {
        Matrix[i] = 0;
    }
}

void Step(int t, int Value[],int Arr_K[])
{
    if (t < M && path == 0)
    {
        for (int i = 0; i< K; i++)
        {
            if (que[t] == Arr_K[i])
            {
                path = t;
            }
        }
        if (path == 0)
        {
            for (int i = 0; i < Matrix[que[t]].size(); i++)
            {
                que.push_back(Matrix[que[t]][i]);
                if (Value[Matrix[que[t + 1]][i]] == 0 || Value[Matrix[que[t + 1]][i]] > t + 1)
                {
                    Value[Matrix[que[t]][i]] = t + 1;
                }
            }
            Step(++t, Value, Arr_K);
        }
    }
}

int main()
{
    ifstream fin("hiking.in");
    ofstream fout("hiking.out");

    cin >> N >> M >> K;
    int Arr[M][2];
    for (int i = 0; i < M; i++)
    {
        cin >> Arr[i][0] >> Arr[i][1];
    }
    int Arr_K[K];
    for (int i = 0; i< K; i++)
    {
        cin >> Arr_K[i];
    }

    for (int i = 0; i < M; i++)
    {
        vector < int > gg;
        Matrix.push_back(gg);
    }
    for (int i = 0; i < M; i++)
    {
        Matrix[Arr[i][0]].push_back(Arr[i][1]);
        Matrix[Arr[i][1]].push_back(Arr[i][0]);
    }

    for (int i = 0; i < K; i++)
    {
        que.clear();
        int Value[N];
        ClearMatrix(Value);
        que.push_back(Arr_K[i]);
        path = 0;
        Step(0, Value, Arr_K);
        if (min_path > path)
        {
            min_path = path;
        }
    }

    cout << min_path;
}
