/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

double trianlge_calc (short int x1, short int y1, short int x2, short int y2, short int x3, short int y3) {

    double a, b, c;

    a = sqrt ( pow ( x1 - x2 , 2 ) + pow ( y1 - y2 , 2 ) );
    b = sqrt ( pow ( x2 - x3 , 2 ) + pow ( y2 - y3 , 2 ) );
    c = sqrt ( pow ( x1 - x3 , 2 ) + pow ( y1 - y3 , 2 ) );

    double p = ( a + b + c ) / 2;

    return sqrt ( p * ( p - a ) * ( p - b) * ( p - c ) );

}

int main () {

    ifstream fin ("triangle.in");
    ofstream fout ("triangle.out");

    unsigned int n;

    fin >> n;

    short int* x = new short int[n];
    short int* y = new short int[n];

    for (unsigned int i = 0; i < n; i++) {

        fin >> x[i] >> y[i];

    }

    fin.close();

    double maxTriangle = 0;
    double buff;

    for (unsigned int i = 0; i < n; i++) {

        for (unsigned int j = 0; j < n; j++) {

            if (j != i) {

                for (unsigned int k = 0; k < n; k++) {

                    if (k != i && k != j) {

                        buff = trianlge_calc(x[i], y[i], x[j], y[j], x[k], y[k]);

                        if (buff > maxTriangle) maxTriangle = buff;

                    }

                }

            }

        }

    }

    fout << maxTriangle << endl;
    fout.close();

    return 0;

}
