/* GCC */
#include <fstream>

using namespace std;

int main()
{
    ifstream file_r;
    file_r.open("hiking.in");
    int squares = 0, roads = 0, stop = 0;
    file_r >> squares >> roads >> stop;
    int graph[squares][squares];
    int distances[squares];
    int visited[squares];
    for(int i = 0; i < squares; i++)
    {
        distances[i] = 10000;
        visited[i] = 0;
        for(int j = 0; j < squares; j++)
        {
            graph[i][j] = 0;
        }
    }
    for(int i = 0; i < roads; i++)
    {
        int first_square = 0, second_square = 0;
        file_r >> first_square >> second_square;
        graph[first_square-1][second_square-1] = 1;
        graph[second_square-1][first_square-1] = 1;
    }
    int stops[stop];
    for(int i = 0; i < stop; i++)
    {
        file_r >> stops[i];
    }
    file_r.close();

    int minindex = 10000;
    int min_distance = 10000;
    int min_temp = 10000;
    for(int i = 0; i < stop; i++)
    {
        int current_stop = stops[i] - 1;
        distances[current_stop] = 0;
        do
        {
            minindex = 10000;
            min_temp = 10000;
            for(int j = 0; j < squares; j++)
            {
                if(visited[j] == 0 && distances[j] < min_temp)
                {
                    minindex = j;
                    min_temp = distances[j];
                }
            }
            if(minindex != 10000)
            {
                for(int j = 0; j < squares; j++)
                {
                    if(graph[minindex][j] != 0)
                    {
                        if(distances[minindex] + 1 < distances[j])
                        {
                            distances[j] = distances[minindex] + 1;
                        }
                    }
                }
                visited[minindex] = 1;
            }
        } while(minindex != 10000);
        for(int j = i + 1; j < stop; j++)
        {
            if(distances[stops[j]-1] < min_distance)
                min_distance = distances[stops[j]-1];
        }
        for(int j = 0; j < squares; j++)
        {
            distances[j] = 10000;
            visited[j] = 0;
        }
    }

    ofstream file_w;
    file_w.open("hiking.out");
    file_w << min_distance << endl;
    file_w.close();

    return 0;
}
