/* GCC */

#include <iostream>
#include <fstream>
#include <string>
#include <math.h>
#include <vector>

using namespace std;

ifstream in("triangle.in");
ofstream out("triangle.out");

double pls(double a,double b, double c)
{

    double p = a+b+c;
    p/=2;
    double m = sqrt(p*(p-a)*(p-b)*(p-c));
    return m;
}

double sqer(int m)
{
    return m*m;
}

double abs(double n){
    n<0?n =-n:n = n;
    return n;
}


int main()
{
    long long n;
    in >> n;
    vector<int> x;
    vector<int> y;
    for(int i = 0;i<n;i++){
        int t;
        in >> t;
        x.push_back(t);
        in >> t;
        y.push_back(t);
    }
    double maxs = 0;
    for(int i = 0;i<n-2;i++){
        for(int j = i+1; j<n-1; j++){
            for(int k = j+1;k<n;k++){
                if(abs(x[j]-x[i])==abs(x[k]-x[j])&&abs(y[j]-y[i])==abs(y[k]-y[j]))continue;
                if(maxs<pls(sqrt(sqer(x[i]-x[j])+sqer(y[i]-y[j])),sqrt(sqer(x[i]-x[k])+sqer(y[i]-y[k])),sqrt(sqer(x[j]-x[k])+sqer(y[j]-y[k]))))maxs = pls(sqrt(sqer(x[i]-x[j])+sqer(y[i]-y[j])),sqrt(sqer(x[i]-x[k])+sqer(y[i]-y[k])),sqrt(sqer(x[j]-x[k])+sqer(y[j]-y[k])));
            }
        }
    }
    out<<maxs<<endl;
    in.close();
    out.close();

    return 0;
}
