/* GCC */


#include <bits/stdc++.h>

#define pii pair<int,int>

#define x first
#define y second

#define en '\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define pll pair<ll,ll>

const ll INF64=1000000000000000000;
const int INF32=1000000000;

using namespace std;


pll arr[2100];

ll sq_len(pii a, pii b){
    return (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y);
}

ll x1,x2,y1,y2;
ll dob_sq_tr(pll &a,pll &b,pll &c){
    x1=a.x-b.x;
    x2=c.x-b.x;
    y1=a.y-b.y;
    y2=c.y-b.y;
    return abs(x1*y2-x2*y1);
}

int main()
{
    freopen("triangle.in","r",stdin);
    freopen("triangle.out","w",stdout);
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin>>n;
    for (int i=1; i<=n; ++i){
        cin>>arr[i].first>>arr[i].second;
    }
    ll ans=0;

    if (n<=170){
        for (int i=1; i<=n; ++i)
            for (int j=i+1; j<=n; ++j)
                for (int q=j+1; q<=n; ++q){
                    ans=max(ans,dob_sq_tr(arr[i],arr[j],arr[q]));
                }
    }else{
        for (int i=1; i<=n; ++i){
            int pos=-1;
            for (int j=1; j<=n; ++j){
                if (j==i) continue;
                if (pos==-1)
                    pos=j;
                else{
                    if (sq_len(arr[i],arr[j])>sq_len(arr[i],arr[pos]))
                        pos=j;
                }
            }

            vector <int> poses;

            for (int j=1; j<=n; ++j){
                if (sq_len(arr[i],arr[j])==sq_len(arr[i],arr[pos]))
                    poses.push_back(j);
            }

            int pos2=-1;

            for (int q=0; q<poses.size(); ++q){
                pos=poses[q];
                for (int j=1; j<=n; ++j){
                    if (j==i || j==pos2){
                        continue;
                    }
                    if (pos2==-1)
                        pos2=j;
                    else{
                        if (dob_sq_tr(arr[i],arr[j],arr[pos])>dob_sq_tr(arr[i],arr[pos],arr[pos2])){
                            pos2=j;
                        }
                    }
                }
            }
            ans=max(ans,dob_sq_tr(arr[i],arr[pos],arr[pos2]));
        }
    }
    if (ans%2){
        cout<<ans/2<<".5"<<en;
    }else
        cout<<ans/2<<en;
    return 0;
}
