""" Python 3 """

with open('cucumbers.in', 'r') as in_file:
	data = list(map(int, in_file.readline().split()))
	m, n = data[0], data[1]
	a = data[2:n+2]
	b = data[n+2:]

prev_state, state = [1], [0]
for _ in range(n):
	prev_state.append(0)
	state.append(0)

for j in range(m):
	state[1:] = prev_state[0:-1]
	state[0] = sum([state[i + 1] * a[i] for i in range(n)])
	prev_state, state = state, prev_state

amount = prev_state[1:]
for k in range(n):
	f, s = amount[k], b[k]
	if f >= s:
		amount[k] = (f + s - 1) // s

with open('cucumbers.out', 'w') as out_file:
	out_file.write(' '.join(map(str, amount)) + '\n')