/* GCC */
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define pii pair<int,int>

#define MAXN 100
#define INF 2000000000
#define MOD 1000000007

ll n, m;
ll A[MAXN];
ll B[MAXN];
ll As[MAXN];
vector<ll> C[MAXN];
ll Rep[MAXN];

ll GCD(ll a, ll b)
{
    while ((a != 0) && (b != 0)){
        if (a == 1) return 1;
        if (b == 1) return 1;
        if (a < b) b = b%a;
        else       a = a%b;
    }

    return a+b;
}

ll LCM(ll a, ll b)
{
    ll res;
    res = a*b;
    res /= GCD(a, b);
    return res;
}

int main(void)
{
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);

    cin >> m >> n;
    for (int i=1; i<=n; i++) cin >> A[i];
    for (int i=1; i<=n; i++) cin >> B[i];

    if (m == 1){
        cout << "1";
        for (int i=2; i<=n; i++) cout << " 0";
        cout << "\n";
        return 0;
    }

    if (m < 2000){
        int NOK=B[1];
        for (int i=2; i<=n; i++) NOK = LCM(NOK, B[i]);

        for (int i=1; i<=n; i++) As[i] = 0;
        As[0] = 1;

        for (int i=0; i<m; i++){
            for (int j=n; j>=1; j--) As[j] = As[j-1];
            As[0] = 0;
            for (int j=1; j<=n; j++){
                As[0] += (As[j]*A[j])%NOK;
                As[0] %= NOK;
            }
        }

        for (int i=1; i<n; i++) cout << As[i]%B[i] << " ";
        cout << As[n]%B[n] << "\n";

        return 0;
    }


    ll x, add, len;
    for (int i=1; i<=n; i++){
        for (int j=0; j<=n; j++) C[i].push_back(0); /// last = n;
        len = n;
        C[i].push_back(1); /// last = n+1
        len++;
        C[i].push_back(A[1]); /// last = n+2
        len++;
        C[i].push_back( (A[1]*C[i][n+2] + A[2]*C[i][n+1])%B[i] );
        len++;
        x = n+3;
        add = 0;
        while ((C[i][x] != C[i][n+2]) || (C[i][x-1] != C[i][n+1])){
            x++;
            add = 0;
            for (int j=1; j<=n; j++){
                if ((x-j) >= 0){
                    add += (A[j]*C[i][x-j])%B[i];
                    add %= B[i];
                }
            }
            C[i].push_back( add );
            len++;
        }
        Rep[i] = x-2-n;
    }
/*
    cout << "   ";
    for (int i=0; i<=n; i++) cout << Rep[i] << " ";
    cout << "\n";
*/
    ll ans, num;
    for (int i=1; i<=n; i++){
        if ((m-i+1) > Rep[i]){
            num = (m-i+1)%Rep[i];
            if (num == 0){
                num = Rep[i];
            }
        }
        else num = m-i+1;
        num += n;

//        cout << " " << num << "\n";

        ans = C[i][num];
        cout << ans%B[i];
        if (i != n) cout << " ";
    }
    cout << "\n";

    return 0;
}
