/* GCC */
#include <bits/stdc++.h>

using namespace std;

int floyd[2000][2000];
int arr[2000];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    int n, m, k;
    cin >> n >> m >> k;

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            floyd[i][j] = 1000000;

    for (int i = 1; i <= n; ++i)
        floyd[i][i] = 0;

    for (int i = 0; i < m; ++i){
        int a, b;
        cin >> a >> b;
        floyd[a][b] = floyd[b][a] = 1;
    }

    for (int l = 1; l <= n; ++l)
        for (int i = 1; i <=n; ++i)
            for (int j = 1; j <= n; ++j)
                floyd[i][j] = min(floyd[i][j], floyd[i][l]+floyd[l][j]);

    int answer = 100000;
    for (int i = 0; i < k; ++i)
        cin >> arr[i];

    for (int i = 0; i < k-1; ++i){
        for (int j = i+1; j < k; ++j)
            answer = min(answer, floyd[arr[i]][arr[j]]);
    }
    cout << answer << '\n';
    return 0;
}


