""" Python 3 """
from math import sqrt
def dist(first, second):
    x1 = first[0]
    y1 = first[1]
    x2 = second[0]
    y2 = second[1]
    b = (x1-x2)**2 + (y1-y2)**2
    return sqrt(b)
f = open("triangle.in")
n = int(f.readline())
vert = []
for line in f:
    vert.append(list(map(int,line.split())))
f.close()
temp = 0
for i in range(n):
    for j in range(i, n):
        for k in range(j, n):
            a = dist(vert[i],vert[j])
            b = dist(vert[i], vert[k])
            c = dist(vert[j], vert[k])
            p = (a+b+c)/2
            s = sqrt(p*(p-a)*(p-b)*(p-c))
            if s > temp:
                temp = s
f = open("triangle.out","w")
if temp > int(temp):
    f.write(str(int(temp)) + ".5\n")
else:
    f.write(str(int(temp)) + "\n")
f.close()
